/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.util;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;

import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.ActionSequence;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Argument;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.AttributeLink;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.CallAction;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.ComponentInstance;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.CreateAction;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.DataValue;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.DestroyAction;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Link;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.LinkEnd;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.LinkObject;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.NodeInstance;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Reception;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.ReturnAction;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.SendAction;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Signal;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.TerminateAction;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.UninterpretedAction;
import fr.obeo.acceleo.uml13.foundation.core.BehavioralFeature;
import fr.obeo.acceleo.uml13.foundation.core.Classifier;
import fr.obeo.acceleo.uml13.foundation.core.Element;
import fr.obeo.acceleo.uml13.foundation.core.Feature;
import fr.obeo.acceleo.uml13.foundation.core.GeneralizableElement;
import fr.obeo.acceleo.uml13.foundation.core.ModelElement;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;

/**
 * <!-- begin-user-doc --> The <b>Switch</b> for the model's inheritance
 * hierarchy. It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object and proceeding up the
 * inheritance hierarchy until a non-null result is returned, which is the
 * result of the switch. <!-- end-user-doc -->
 * 
 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage
 * @generated
 */
public class Common_behaviorSwitch {
	/**
	 * The cached model package <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected static Common_behaviorPackage modelPackage;

	/**
	 * Creates an instance of the switch. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public Common_behaviorSwitch() {
		if (modelPackage == null) {
			modelPackage = Common_behaviorPackage.eINSTANCE;
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one
	 * returns a non null result; it yields that result. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	public Object doSwitch(EObject theEObject) {
		return doSwitch(theEObject.eClass(), theEObject);
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one
	 * returns a non null result; it yields that result. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	protected Object doSwitch(EClass theEClass, EObject theEObject) {
		if (theEClass.eContainer() == modelPackage) {
			return doSwitch(theEClass.getClassifierID(), theEObject);
		} else {
			List eSuperTypes = theEClass.getESuperTypes();
			return eSuperTypes.isEmpty() ? defaultCase(theEObject) : doSwitch((EClass) eSuperTypes.get(0), theEObject);
		}
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one
	 * returns a non null result; it yields that result. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @return the first non-null result returned by a <code>caseXXX</code>
	 *         call.
	 * @generated
	 */
	protected Object doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
		case Common_behaviorPackage.INSTANCE: {
			Instance instance = (Instance) theEObject;
			Object result = caseInstance(instance);
			if (result == null)
				result = caseModelElement(instance);
			if (result == null)
				result = caseElement(instance);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.SIGNAL: {
			Signal signal = (Signal) theEObject;
			Object result = caseSignal(signal);
			if (result == null)
				result = caseClassifier(signal);
			if (result == null)
				result = caseGeneralizableElement(signal);
			if (result == null)
				result = caseNamespace(signal);
			if (result == null)
				result = caseModelElement(signal);
			if (result == null)
				result = caseElement(signal);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.ACTION: {
			Action action = (Action) theEObject;
			Object result = caseAction(action);
			if (result == null)
				result = caseModelElement(action);
			if (result == null)
				result = caseElement(action);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.CREATE_ACTION: {
			CreateAction createAction = (CreateAction) theEObject;
			Object result = caseCreateAction(createAction);
			if (result == null)
				result = caseAction(createAction);
			if (result == null)
				result = caseModelElement(createAction);
			if (result == null)
				result = caseElement(createAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.DESTROY_ACTION: {
			DestroyAction destroyAction = (DestroyAction) theEObject;
			Object result = caseDestroyAction(destroyAction);
			if (result == null)
				result = caseAction(destroyAction);
			if (result == null)
				result = caseModelElement(destroyAction);
			if (result == null)
				result = caseElement(destroyAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.UNINTERPRETED_ACTION: {
			UninterpretedAction uninterpretedAction = (UninterpretedAction) theEObject;
			Object result = caseUninterpretedAction(uninterpretedAction);
			if (result == null)
				result = caseAction(uninterpretedAction);
			if (result == null)
				result = caseModelElement(uninterpretedAction);
			if (result == null)
				result = caseElement(uninterpretedAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.ATTRIBUTE_LINK: {
			AttributeLink attributeLink = (AttributeLink) theEObject;
			Object result = caseAttributeLink(attributeLink);
			if (result == null)
				result = caseModelElement(attributeLink);
			if (result == null)
				result = caseElement(attributeLink);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.OBJECT: {
			fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Object object = (fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Object) theEObject;
			Object result = caseObject(object);
			if (result == null)
				result = caseInstance(object);
			if (result == null)
				result = caseModelElement(object);
			if (result == null)
				result = caseElement(object);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.LINK: {
			Link link = (Link) theEObject;
			Object result = caseLink(link);
			if (result == null)
				result = caseModelElement(link);
			if (result == null)
				result = caseElement(link);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.LINK_OBJECT: {
			LinkObject linkObject = (LinkObject) theEObject;
			Object result = caseLinkObject(linkObject);
			if (result == null)
				result = caseObject(linkObject);
			if (result == null)
				result = caseLink(linkObject);
			if (result == null)
				result = caseInstance(linkObject);
			if (result == null)
				result = caseModelElement(linkObject);
			if (result == null)
				result = caseElement(linkObject);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.DATA_VALUE: {
			DataValue dataValue = (DataValue) theEObject;
			Object result = caseDataValue(dataValue);
			if (result == null)
				result = caseInstance(dataValue);
			if (result == null)
				result = caseModelElement(dataValue);
			if (result == null)
				result = caseElement(dataValue);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.CALL_ACTION: {
			CallAction callAction = (CallAction) theEObject;
			Object result = caseCallAction(callAction);
			if (result == null)
				result = caseAction(callAction);
			if (result == null)
				result = caseModelElement(callAction);
			if (result == null)
				result = caseElement(callAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.SEND_ACTION: {
			SendAction sendAction = (SendAction) theEObject;
			Object result = caseSendAction(sendAction);
			if (result == null)
				result = caseAction(sendAction);
			if (result == null)
				result = caseModelElement(sendAction);
			if (result == null)
				result = caseElement(sendAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.ACTION_SEQUENCE: {
			ActionSequence actionSequence = (ActionSequence) theEObject;
			Object result = caseActionSequence(actionSequence);
			if (result == null)
				result = caseAction(actionSequence);
			if (result == null)
				result = caseModelElement(actionSequence);
			if (result == null)
				result = caseElement(actionSequence);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.ARGUMENT: {
			Argument argument = (Argument) theEObject;
			Object result = caseArgument(argument);
			if (result == null)
				result = caseModelElement(argument);
			if (result == null)
				result = caseElement(argument);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.RECEPTION: {
			Reception reception = (Reception) theEObject;
			Object result = caseReception(reception);
			if (result == null)
				result = caseBehavioralFeature(reception);
			if (result == null)
				result = caseFeature(reception);
			if (result == null)
				result = caseModelElement(reception);
			if (result == null)
				result = caseElement(reception);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.LINK_END: {
			LinkEnd linkEnd = (LinkEnd) theEObject;
			Object result = caseLinkEnd(linkEnd);
			if (result == null)
				result = caseModelElement(linkEnd);
			if (result == null)
				result = caseElement(linkEnd);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.RETURN_ACTION: {
			ReturnAction returnAction = (ReturnAction) theEObject;
			Object result = caseReturnAction(returnAction);
			if (result == null)
				result = caseAction(returnAction);
			if (result == null)
				result = caseModelElement(returnAction);
			if (result == null)
				result = caseElement(returnAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.TERMINATE_ACTION: {
			TerminateAction terminateAction = (TerminateAction) theEObject;
			Object result = caseTerminateAction(terminateAction);
			if (result == null)
				result = caseAction(terminateAction);
			if (result == null)
				result = caseModelElement(terminateAction);
			if (result == null)
				result = caseElement(terminateAction);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.STIMULUS: {
			Stimulus stimulus = (Stimulus) theEObject;
			Object result = caseStimulus(stimulus);
			if (result == null)
				result = caseModelElement(stimulus);
			if (result == null)
				result = caseElement(stimulus);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.EXCEPTION: {
			fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Exception exception = (fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Exception) theEObject;
			Object result = caseException(exception);
			if (result == null)
				result = caseSignal(exception);
			if (result == null)
				result = caseClassifier(exception);
			if (result == null)
				result = caseGeneralizableElement(exception);
			if (result == null)
				result = caseNamespace(exception);
			if (result == null)
				result = caseModelElement(exception);
			if (result == null)
				result = caseElement(exception);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.COMPONENT_INSTANCE: {
			ComponentInstance componentInstance = (ComponentInstance) theEObject;
			Object result = caseComponentInstance(componentInstance);
			if (result == null)
				result = caseInstance(componentInstance);
			if (result == null)
				result = caseModelElement(componentInstance);
			if (result == null)
				result = caseElement(componentInstance);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		case Common_behaviorPackage.NODE_INSTANCE: {
			NodeInstance nodeInstance = (NodeInstance) theEObject;
			Object result = caseNodeInstance(nodeInstance);
			if (result == null)
				result = caseInstance(nodeInstance);
			if (result == null)
				result = caseModelElement(nodeInstance);
			if (result == null)
				result = caseElement(nodeInstance);
			if (result == null)
				result = defaultCase(theEObject);
			return result;
		}
		default:
			return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Instance</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Instance</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseInstance(Instance object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Signal</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Signal</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSignal(Signal object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Action</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAction(Action object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Create Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Create Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCreateAction(CreateAction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Destroy Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Destroy Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDestroyAction(DestroyAction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Uninterpreted Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Uninterpreted Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseUninterpretedAction(UninterpretedAction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Attribute Link</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Attribute Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseAttributeLink(AttributeLink object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Object</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseObject(fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Object object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Link</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Link</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseLink(Link object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Link Object</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Link Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseLinkObject(LinkObject object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Data Value</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Data Value</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseDataValue(DataValue object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Call Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Call Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseCallAction(CallAction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Send Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Send Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseSendAction(SendAction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Action Sequence</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Action Sequence</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseActionSequence(ActionSequence object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Argument</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Argument</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseArgument(Argument object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Reception</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Reception</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseReception(Reception object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Link End</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Link End</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseLinkEnd(LinkEnd object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Return Action</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Return Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseReturnAction(ReturnAction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Terminate Action</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Terminate Action</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseTerminateAction(TerminateAction object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Stimulus</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Stimulus</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseStimulus(Stimulus object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Exception</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Exception</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseException(fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Exception object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Component Instance</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Component Instance</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseComponentInstance(ComponentInstance object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Node Instance</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Node Instance</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseNodeInstance(NodeInstance object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Element</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseElement(Element object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Model Element</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Model Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseModelElement(ModelElement object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Generalizable Element</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Generalizable Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseGeneralizableElement(GeneralizableElement object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Namespace</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Namespace</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseNamespace(Namespace object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Classifier</em>'. <!-- begin-user-doc --> This implementation
	 * returns null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Classifier</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseClassifier(Classifier object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Feature</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch. <!--
	 * end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Feature</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseFeature(Feature object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>Behavioral Feature</em>'. <!-- begin-user-doc --> This
	 * implementation returns null; returning a non-null result will terminate
	 * the switch. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>Behavioral Feature</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public Object caseBehavioralFeature(BehavioralFeature object) {
		return null;
	}

	/**
	 * Returns the result of interpretting the object as an instance of '
	 * <em>EObject</em>'. <!-- begin-user-doc --> This implementation returns
	 * null; returning a non-null result will terminate the switch, but this is
	 * the last case anyway. <!-- end-user-doc -->
	 * 
	 * @param object
	 *            the target of the switch.
	 * @return the result of interpretting the object as an instance of '
	 *         <em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	public Object defaultCase(EObject object) {
		return null;
	}

} // Common_behaviorSwitch
