/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Activity_graphsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ClassifierInState;
import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ObjectFlowState;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.CreateAction;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml13.foundation.core.AssociationEnd;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.Classifier;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Feature;
import fr.obeo.acceleo.uml13.foundation.core.Generalization;
import fr.obeo.acceleo.uml13.foundation.core.ModelElement;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Classifier</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl#getOwnedElement
 * <em>Owned Element</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl#getFeature
 * <em>Feature</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl#getParticipant
 * <em>Participant</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl#getPowertypeRange
 * <em>Powertype Range</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl#getInstance
 * <em>Instance</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl#getCreateAction
 * <em>Create Action</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl#getClassifierInState
 * <em>Classifier In State</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl#getObjectFlowState
 * <em>Object Flow State</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class ClassifierImpl extends GeneralizableElementImpl implements Classifier {
	/**
	 * The cached value of the '{@link #getOwnedElement()
	 * <em>Owned Element</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOwnedElement()
	 * @generated
	 * @ordered
	 */
	protected EList ownedElement = null;

	/**
	 * The cached value of the '{@link #getFeature() <em>Feature</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getFeature()
	 * @generated
	 * @ordered
	 */
	protected EList feature = null;

	/**
	 * The cached value of the '{@link #getParticipant() <em>Participant</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getParticipant()
	 * @generated
	 * @ordered
	 */
	protected EList participant = null;

	/**
	 * The cached value of the '{@link #getPowertypeRange()
	 * <em>Powertype Range</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getPowertypeRange()
	 * @generated
	 * @ordered
	 */
	protected EList powertypeRange = null;

	/**
	 * The cached value of the '{@link #getInstance() <em>Instance</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getInstance()
	 * @generated
	 * @ordered
	 */
	protected EList instance = null;

	/**
	 * The cached value of the '{@link #getCreateAction()
	 * <em>Create Action</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getCreateAction()
	 * @generated
	 * @ordered
	 */
	protected EList createAction = null;

	/**
	 * The cached value of the '{@link #getClassifierInState()
	 * <em>Classifier In State</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getClassifierInState()
	 * @generated
	 * @ordered
	 */
	protected EList classifierInState = null;

	/**
	 * The cached value of the '{@link #getObjectFlowState()
	 * <em>Object Flow State</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getObjectFlowState()
	 * @generated
	 * @ordered
	 */
	protected EList objectFlowState = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ClassifierImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CorePackage.eINSTANCE.getClassifier();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getOwnedElement() {
		if (ownedElement == null) {
			ownedElement = new EObjectContainmentWithInverseEList(ModelElement.class, this, CorePackage.CLASSIFIER__OWNED_ELEMENT, CorePackage.MODEL_ELEMENT__NAMESPACE);
		}
		return ownedElement;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getFeature() {
		if (feature == null) {
			feature = new EObjectContainmentWithInverseEList(Feature.class, this, CorePackage.CLASSIFIER__FEATURE, CorePackage.FEATURE__OWNER);
		}
		return feature;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getParticipant() {
		if (participant == null) {
			participant = new EObjectWithInverseResolvingEList.ManyInverse(AssociationEnd.class, this, CorePackage.CLASSIFIER__PARTICIPANT, CorePackage.ASSOCIATION_END__SPECIFICATION);
		}
		return participant;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getPowertypeRange() {
		if (powertypeRange == null) {
			powertypeRange = new EObjectWithInverseResolvingEList(Generalization.class, this, CorePackage.CLASSIFIER__POWERTYPE_RANGE, CorePackage.GENERALIZATION__POWERTYPE);
		}
		return powertypeRange;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getInstance() {
		if (instance == null) {
			instance = new EObjectWithInverseResolvingEList.ManyInverse(Instance.class, this, CorePackage.CLASSIFIER__INSTANCE, Common_behaviorPackage.INSTANCE__CLASSIFIER);
		}
		return instance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getCreateAction() {
		if (createAction == null) {
			createAction = new EObjectWithInverseResolvingEList(CreateAction.class, this, CorePackage.CLASSIFIER__CREATE_ACTION, Common_behaviorPackage.CREATE_ACTION__INSTANTIATION);
		}
		return createAction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getClassifierInState() {
		if (classifierInState == null) {
			classifierInState = new EObjectWithInverseResolvingEList(ClassifierInState.class, this, CorePackage.CLASSIFIER__CLASSIFIER_IN_STATE, Activity_graphsPackage.CLASSIFIER_IN_STATE__TYPE);
		}
		return classifierInState;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getObjectFlowState() {
		if (objectFlowState == null) {
			objectFlowState = new EObjectWithInverseResolvingEList(ObjectFlowState.class, this, CorePackage.CLASSIFIER__OBJECT_FLOW_STATE, Activity_graphsPackage.OBJECT_FLOW_STATE__TYPE);
		}
		return objectFlowState;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.CLASSIFIER__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.CLASSIFIER__NAMESPACE, msgs);
			case CorePackage.CLASSIFIER__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case CorePackage.CLASSIFIER__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case CorePackage.CLASSIFIER__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__FEATURE:
				return ((InternalEList) getFeature()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__PARTICIPANT:
				return ((InternalEList) getParticipant()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__INSTANCE:
				return ((InternalEList) getInstance()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			case CorePackage.CLASSIFIER__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.CLASSIFIER__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__NAMESPACE:
				return eBasicSetContainer(null, CorePackage.CLASSIFIER__NAMESPACE, msgs);
			case CorePackage.CLASSIFIER__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__BINDING:
				return basicSetBinding(null, msgs);
			case CorePackage.CLASSIFIER__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case CorePackage.CLASSIFIER__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__FEATURE:
				return ((InternalEList) getFeature()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__PARTICIPANT:
				return ((InternalEList) getParticipant()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__INSTANCE:
				return ((InternalEList) getInstance()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			case CorePackage.CLASSIFIER__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CorePackage.CLASSIFIER__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.CLASSIFIER__ELEMENT_IMPORT:
			return getElementImport();
		case CorePackage.CLASSIFIER__NAME:
			return getName();
		case CorePackage.CLASSIFIER__VISIBILITY:
			return getVisibility();
		case CorePackage.CLASSIFIER__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.CLASSIFIER__NAMESPACE:
			return getNamespace();
		case CorePackage.CLASSIFIER__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CorePackage.CLASSIFIER__CONSTRAINT:
			return getConstraint();
		case CorePackage.CLASSIFIER__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CorePackage.CLASSIFIER__PRESENTATION:
			return getPresentation();
		case CorePackage.CLASSIFIER__TARGET_FLOW:
			return getTargetFlow();
		case CorePackage.CLASSIFIER__SOURCE_FLOW:
			return getSourceFlow();
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case CorePackage.CLASSIFIER__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case CorePackage.CLASSIFIER__COMMENT:
			return getComment();
		case CorePackage.CLASSIFIER__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case CorePackage.CLASSIFIER__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case CorePackage.CLASSIFIER__TAGGED_VALUE:
			return getTaggedValue();
		case CorePackage.CLASSIFIER__BEHAVIOR:
			return getBehavior();
		case CorePackage.CLASSIFIER__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CorePackage.CLASSIFIER__COLLABORATION:
			return getCollaboration();
		case CorePackage.CLASSIFIER__PARTITION:
			return getPartition();
		case CorePackage.CLASSIFIER__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.CLASSIFIER__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.CLASSIFIER__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.CLASSIFIER__GENERALIZATION:
			return getGeneralization();
		case CorePackage.CLASSIFIER__SPECIALIZATION:
			return getSpecialization();
		case CorePackage.CLASSIFIER__OWNED_ELEMENT:
			return getOwnedElement();
		case CorePackage.CLASSIFIER__FEATURE:
			return getFeature();
		case CorePackage.CLASSIFIER__PARTICIPANT:
			return getParticipant();
		case CorePackage.CLASSIFIER__POWERTYPE_RANGE:
			return getPowertypeRange();
		case CorePackage.CLASSIFIER__INSTANCE:
			return getInstance();
		case CorePackage.CLASSIFIER__CREATE_ACTION:
			return getCreateAction();
		case CorePackage.CLASSIFIER__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		case CorePackage.CLASSIFIER__OBJECT_FLOW_STATE:
			return getObjectFlowState();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.CLASSIFIER__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__NAME:
			setName((String) newValue);
			return;
		case CorePackage.CLASSIFIER__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case CorePackage.CLASSIFIER__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.CLASSIFIER__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CorePackage.CLASSIFIER__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__BINDING:
			setBinding((Binding) newValue);
			return;
		case CorePackage.CLASSIFIER__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case CorePackage.CLASSIFIER__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.CLASSIFIER__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.CLASSIFIER__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.CLASSIFIER__GENERALIZATION:
			getGeneralization().clear();
			getGeneralization().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__SPECIALIZATION:
			getSpecialization().clear();
			getSpecialization().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__OWNED_ELEMENT:
			getOwnedElement().clear();
			getOwnedElement().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__FEATURE:
			getFeature().clear();
			getFeature().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__PARTICIPANT:
			getParticipant().clear();
			getParticipant().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			getPowertypeRange().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__INSTANCE:
			getInstance().clear();
			getInstance().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__CREATE_ACTION:
			getCreateAction().clear();
			getCreateAction().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		case CorePackage.CLASSIFIER__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			getObjectFlowState().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.CLASSIFIER__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CorePackage.CLASSIFIER__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CorePackage.CLASSIFIER__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CorePackage.CLASSIFIER__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CorePackage.CLASSIFIER__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CorePackage.CLASSIFIER__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CorePackage.CLASSIFIER__CONSTRAINT:
			getConstraint().clear();
			return;
		case CorePackage.CLASSIFIER__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CorePackage.CLASSIFIER__PRESENTATION:
			getPresentation().clear();
			return;
		case CorePackage.CLASSIFIER__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CorePackage.CLASSIFIER__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case CorePackage.CLASSIFIER__BINDING:
			setBinding((Binding) null);
			return;
		case CorePackage.CLASSIFIER__COMMENT:
			getComment().clear();
			return;
		case CorePackage.CLASSIFIER__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case CorePackage.CLASSIFIER__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case CorePackage.CLASSIFIER__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CorePackage.CLASSIFIER__BEHAVIOR:
			getBehavior().clear();
			return;
		case CorePackage.CLASSIFIER__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CorePackage.CLASSIFIER__COLLABORATION:
			getCollaboration().clear();
			return;
		case CorePackage.CLASSIFIER__PARTITION:
			getPartition().clear();
			return;
		case CorePackage.CLASSIFIER__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case CorePackage.CLASSIFIER__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case CorePackage.CLASSIFIER__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case CorePackage.CLASSIFIER__GENERALIZATION:
			getGeneralization().clear();
			return;
		case CorePackage.CLASSIFIER__SPECIALIZATION:
			getSpecialization().clear();
			return;
		case CorePackage.CLASSIFIER__OWNED_ELEMENT:
			getOwnedElement().clear();
			return;
		case CorePackage.CLASSIFIER__FEATURE:
			getFeature().clear();
			return;
		case CorePackage.CLASSIFIER__PARTICIPANT:
			getParticipant().clear();
			return;
		case CorePackage.CLASSIFIER__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			return;
		case CorePackage.CLASSIFIER__INSTANCE:
			getInstance().clear();
			return;
		case CorePackage.CLASSIFIER__CREATE_ACTION:
			getCreateAction().clear();
			return;
		case CorePackage.CLASSIFIER__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		case CorePackage.CLASSIFIER__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.CLASSIFIER__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CorePackage.CLASSIFIER__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CorePackage.CLASSIFIER__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case CorePackage.CLASSIFIER__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CorePackage.CLASSIFIER__NAMESPACE:
			return getNamespace() != null;
		case CorePackage.CLASSIFIER__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CorePackage.CLASSIFIER__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CorePackage.CLASSIFIER__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CorePackage.CLASSIFIER__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CorePackage.CLASSIFIER__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CorePackage.CLASSIFIER__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case CorePackage.CLASSIFIER__BINDING:
			return binding != null;
		case CorePackage.CLASSIFIER__COMMENT:
			return comment != null && !comment.isEmpty();
		case CorePackage.CLASSIFIER__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CorePackage.CLASSIFIER__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case CorePackage.CLASSIFIER__STEREOTYPE:
			return stereotype != null;
		case CorePackage.CLASSIFIER__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CorePackage.CLASSIFIER__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CorePackage.CLASSIFIER__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CorePackage.CLASSIFIER__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CorePackage.CLASSIFIER__PARTITION:
			return partition != null && !partition.isEmpty();
		case CorePackage.CLASSIFIER__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case CorePackage.CLASSIFIER__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case CorePackage.CLASSIFIER__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case CorePackage.CLASSIFIER__GENERALIZATION:
			return generalization != null && !generalization.isEmpty();
		case CorePackage.CLASSIFIER__SPECIALIZATION:
			return specialization != null && !specialization.isEmpty();
		case CorePackage.CLASSIFIER__OWNED_ELEMENT:
			return ownedElement != null && !ownedElement.isEmpty();
		case CorePackage.CLASSIFIER__FEATURE:
			return feature != null && !feature.isEmpty();
		case CorePackage.CLASSIFIER__PARTICIPANT:
			return participant != null && !participant.isEmpty();
		case CorePackage.CLASSIFIER__POWERTYPE_RANGE:
			return powertypeRange != null && !powertypeRange.isEmpty();
		case CorePackage.CLASSIFIER__INSTANCE:
			return instance != null && !instance.isEmpty();
		case CorePackage.CLASSIFIER__CREATE_ACTION:
			return createAction != null && !createAction.isEmpty();
		case CorePackage.CLASSIFIER__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		case CorePackage.CLASSIFIER__OBJECT_FLOW_STATE:
			return objectFlowState != null && !objectFlowState.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == Namespace.class) {
			switch (derivedFeatureID) {
			case CorePackage.CLASSIFIER__OWNED_ELEMENT:
				return CorePackage.NAMESPACE__OWNED_ELEMENT;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == Namespace.class) {
			switch (baseFeatureID) {
			case CorePackage.NAMESPACE__OWNED_ELEMENT:
				return CorePackage.CLASSIFIER__OWNED_ELEMENT;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} // ClassifierImpl
