/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.AssociationRole;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Link;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.LinkEnd;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus;
import fr.obeo.acceleo.uml14.foundation.core.Association;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Link</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkImpl#getAssociation
 * <em>Association</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkImpl#getConnection
 * <em>Connection</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkImpl#getStimulus
 * <em>Stimulus</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkImpl#getOwner
 * <em>Owner</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkImpl#getPlayedRole
 * <em>Played Role</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class LinkImpl extends ModelElementImpl implements Link {
	/**
	 * The cached value of the '{@link #getAssociation() <em>Association</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAssociation()
	 * @generated
	 * @ordered
	 */
	protected Association association = null;

	/**
	 * The cached value of the '{@link #getConnection() <em>Connection</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getConnection()
	 * @generated
	 * @ordered
	 */
	protected EList connection = null;

	/**
	 * The cached value of the '{@link #getStimulus() <em>Stimulus</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStimulus()
	 * @generated
	 * @ordered
	 */
	protected EList stimulus = null;

	/**
	 * The cached value of the '{@link #getPlayedRole() <em>Played Role</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getPlayedRole()
	 * @generated
	 * @ordered
	 */
	protected EList playedRole = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected LinkImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getLink();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Association getAssociation() {
		if (association != null && association.eIsProxy()) {
			Association oldAssociation = association;
			association = (Association) eResolveProxy((InternalEObject) association);
			if (association != oldAssociation) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.LINK__ASSOCIATION, oldAssociation, association));
			}
		}
		return association;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Association basicGetAssociation() {
		return association;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetAssociation(Association newAssociation, NotificationChain msgs) {
		Association oldAssociation = association;
		association = newAssociation;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.LINK__ASSOCIATION, oldAssociation, newAssociation);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAssociation(Association newAssociation) {
		if (newAssociation != association) {
			NotificationChain msgs = null;
			if (association != null)
				msgs = ((InternalEObject) association).eInverseRemove(this, CorePackage.ASSOCIATION__LINK, Association.class, msgs);
			if (newAssociation != null)
				msgs = ((InternalEObject) newAssociation).eInverseAdd(this, CorePackage.ASSOCIATION__LINK, Association.class, msgs);
			msgs = basicSetAssociation(newAssociation, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.LINK__ASSOCIATION, newAssociation, newAssociation));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getConnection() {
		if (connection == null) {
			connection = new EObjectContainmentWithInverseEList(LinkEnd.class, this, Common_behaviorPackage.LINK__CONNECTION, Common_behaviorPackage.LINK_END__LINK);
		}
		return connection;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getStimulus() {
		if (stimulus == null) {
			stimulus = new EObjectWithInverseResolvingEList(Stimulus.class, this, Common_behaviorPackage.LINK__STIMULUS, Common_behaviorPackage.STIMULUS__COMMUNICATION_LINK);
		}
		return stimulus;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance getOwner() {
		if (eContainerFeatureID != Common_behaviorPackage.LINK__OWNER)
			return null;
		return (Instance) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setOwner(Instance newOwner) {
		if (newOwner != eContainer || (eContainerFeatureID != Common_behaviorPackage.LINK__OWNER && newOwner != null)) {
			if (EcoreUtil.isAncestor(this, newOwner))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newOwner != null)
				msgs = ((InternalEObject) newOwner).eInverseAdd(this, Common_behaviorPackage.INSTANCE__OWNED_LINK, Instance.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newOwner, Common_behaviorPackage.LINK__OWNER, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.LINK__OWNER, newOwner, newOwner));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getPlayedRole() {
		if (playedRole == null) {
			playedRole = new EObjectWithInverseResolvingEList.ManyInverse(AssociationRole.class, this, Common_behaviorPackage.LINK__PLAYED_ROLE,
					CollaborationsPackage.ASSOCIATION_ROLE__CONFORMING_LINK);
		}
		return playedRole;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.LINK__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.LINK__NAMESPACE, msgs);
			case Common_behaviorPackage.LINK__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.LINK__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.LINK__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__ASSOCIATION:
				if (association != null)
					msgs = ((InternalEObject) association).eInverseRemove(this, CorePackage.ASSOCIATION__LINK, Association.class, msgs);
				return basicSetAssociation((Association) otherEnd, msgs);
			case Common_behaviorPackage.LINK__CONNECTION:
				return ((InternalEList) getConnection()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__STIMULUS:
				return ((InternalEList) getStimulus()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK__OWNER:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.LINK__OWNER, msgs);
			case Common_behaviorPackage.LINK__PLAYED_ROLE:
				return ((InternalEList) getPlayedRole()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.LINK__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.LINK__NAMESPACE, msgs);
			case Common_behaviorPackage.LINK__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, Common_behaviorPackage.LINK__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.LINK__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__ASSOCIATION:
				return basicSetAssociation(null, msgs);
			case Common_behaviorPackage.LINK__CONNECTION:
				return ((InternalEList) getConnection()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__STIMULUS:
				return ((InternalEList) getStimulus()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK__OWNER:
				return eBasicSetContainer(null, Common_behaviorPackage.LINK__OWNER, msgs);
			case Common_behaviorPackage.LINK__PLAYED_ROLE:
				return ((InternalEList) getPlayedRole()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.LINK__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Common_behaviorPackage.LINK__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case Common_behaviorPackage.LINK__OWNER:
				return eContainer.eInverseRemove(this, Common_behaviorPackage.INSTANCE__OWNED_LINK, Instance.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.LINK__NAME:
			return getName();
		case Common_behaviorPackage.LINK__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.LINK__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.LINK__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.LINK__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.LINK__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.LINK__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.LINK__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.LINK__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.LINK__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.LINK__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case Common_behaviorPackage.LINK__COMMENT:
			return getComment();
		case Common_behaviorPackage.LINK__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.LINK__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.LINK__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case Common_behaviorPackage.LINK__STEREOTYPE:
			return getStereotype();
		case Common_behaviorPackage.LINK__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.LINK__REFERENCE_TAG:
			return getReferenceTag();
		case Common_behaviorPackage.LINK__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case Common_behaviorPackage.LINK__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.LINK__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.LINK__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.LINK__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case Common_behaviorPackage.LINK__PARTITION:
			return getPartition();
		case Common_behaviorPackage.LINK__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.LINK__ASSOCIATION:
			if (resolve)
				return getAssociation();
			return basicGetAssociation();
		case Common_behaviorPackage.LINK__CONNECTION:
			return getConnection();
		case Common_behaviorPackage.LINK__STIMULUS:
			return getStimulus();
		case Common_behaviorPackage.LINK__OWNER:
			return getOwner();
		case Common_behaviorPackage.LINK__PLAYED_ROLE:
			return getPlayedRole();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.LINK__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.LINK__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case Common_behaviorPackage.LINK__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.LINK__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.LINK__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case Common_behaviorPackage.LINK__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__ASSOCIATION:
			setAssociation((Association) newValue);
			return;
		case Common_behaviorPackage.LINK__CONNECTION:
			getConnection().clear();
			getConnection().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__STIMULUS:
			getStimulus().clear();
			getStimulus().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK__OWNER:
			setOwner((Instance) newValue);
			return;
		case Common_behaviorPackage.LINK__PLAYED_ROLE:
			getPlayedRole().clear();
			getPlayedRole().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.LINK__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.LINK__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.LINK__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.LINK__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.LINK__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.LINK__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.LINK__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.LINK__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.LINK__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.LINK__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.LINK__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case Common_behaviorPackage.LINK__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.LINK__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.LINK__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.LINK__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case Common_behaviorPackage.LINK__STEREOTYPE:
			getStereotype().clear();
			return;
		case Common_behaviorPackage.LINK__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.LINK__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case Common_behaviorPackage.LINK__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case Common_behaviorPackage.LINK__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.LINK__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.LINK__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.LINK__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case Common_behaviorPackage.LINK__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.LINK__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.LINK__ASSOCIATION:
			setAssociation((Association) null);
			return;
		case Common_behaviorPackage.LINK__CONNECTION:
			getConnection().clear();
			return;
		case Common_behaviorPackage.LINK__STIMULUS:
			getStimulus().clear();
			return;
		case Common_behaviorPackage.LINK__OWNER:
			setOwner((Instance) null);
			return;
		case Common_behaviorPackage.LINK__PLAYED_ROLE:
			getPlayedRole().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.LINK__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.LINK__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case Common_behaviorPackage.LINK__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.LINK__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.LINK__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.LINK__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.LINK__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.LINK__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.LINK__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.LINK__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.LINK__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case Common_behaviorPackage.LINK__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.LINK__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.LINK__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.LINK__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case Common_behaviorPackage.LINK__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case Common_behaviorPackage.LINK__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.LINK__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case Common_behaviorPackage.LINK__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case Common_behaviorPackage.LINK__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.LINK__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.LINK__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.LINK__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case Common_behaviorPackage.LINK__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.LINK__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.LINK__ASSOCIATION:
			return association != null;
		case Common_behaviorPackage.LINK__CONNECTION:
			return connection != null && !connection.isEmpty();
		case Common_behaviorPackage.LINK__STIMULUS:
			return stimulus != null && !stimulus.isEmpty();
		case Common_behaviorPackage.LINK__OWNER:
			return getOwner() != null;
		case Common_behaviorPackage.LINK__PLAYED_ROLE:
			return playedRole != null && !playedRole.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // LinkImpl
